#include <bits/stdc++.h>
using namespace std;

int main(){
	int n, m;
	scanf("%d%d", &n, &m);
	int a[m], b[m], t[m];
	int ta[n]={0}, tb[n]={0};
	for(int i=0; i<m; i++){
		scanf("%d%d%d", a+i, b+i, t+i);
		a[i]--;
		b[i]--;
	}
	int u, v;
	scanf("%d%d", &u, &v);
	u--; v--;
	ta[u]=1;
	
	bool TypeToSpread=0;
	int flipper=1;
	
	for(int i=0; i<n; i++){
		for(int j=0; j<m; j++){
			if(ta[a[j]]!=0 and ta[b[j]]==0 and t[j]==TypeToSpread){
				//printf("o");
				ta[b[j]]=flipper;
			}
			else{
				if(ta[b[j]]!=0 and ta[a[j]]==0 and t[j]==TypeToSpread){
					//printf("o");
					ta[a[j]]=flipper;
				}
			}
		}
		flipper+=1;
		TypeToSpread=1-TypeToSpread;
		//printf("FLIP");
	}/*
	for(int i=0; i<n; i++){
		printf("%d", ta[i]-1);
	}*/
	printf("%d", ta[v]-1);
}